/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.adaptation;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see edu.kit.ipd.descartes.mm.adaptation.AdaptationPackage
 * @generated
 */
public interface AdaptationFactory extends EFactory {
    /**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    AdaptationFactory eINSTANCE = edu.kit.ipd.descartes.mm.adaptation.impl.AdaptationFactoryImpl.init();

    /**
	 * Returns a new object of class '<em>Process</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>Process</em>'.
	 * @generated
	 */
    AdaptationProcess createAdaptationProcess();

    /**
	 * Returns a new object of class '<em>Overall Goal</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>Overall Goal</em>'.
	 * @generated
	 */
    OverallGoal createOverallGoal();

    /**
	 * Returns a new object of class '<em>Strategy</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>Strategy</em>'.
	 * @generated
	 */
    Strategy createStrategy();

    /**
	 * Returns a new object of class '<em>Event</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>Event</em>'.
	 * @generated
	 */
    Event createEvent();

    /**
	 * Returns a new object of class '<em>Objective</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>Objective</em>'.
	 * @generated
	 */
    Objective createObjective();

    /**
	 * Returns a new object of class '<em>Specification</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>Specification</em>'.
	 * @generated
	 */
    Specification createSpecification();

    /**
	 * Returns a new object of class '<em>Weighting Function</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>Weighting Function</em>'.
	 * @generated
	 */
    WeightingFunction createWeightingFunction();

    /**
	 * Returns a new object of class '<em>Weighted Metric</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>Weighted Metric</em>'.
	 * @generated
	 */
    WeightedMetric createWeightedMetric();

    /**
	 * Returns a new object of class '<em>Weighted Tactic</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>Weighted Tactic</em>'.
	 * @generated
	 */
    WeightedTactic createWeightedTactic();

    /**
	 * Returns a new object of class '<em>Tactic</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>Tactic</em>'.
	 * @generated
	 */
    Tactic createTactic();

    /**
	 * Returns a new object of class '<em>Start Action</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>Start Action</em>'.
	 * @generated
	 */
    StartAction createStartAction();

    /**
	 * Returns a new object of class '<em>Stop Action</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>Stop Action</em>'.
	 * @generated
	 */
    StopAction createStopAction();

    /**
	 * Returns a new object of class '<em>Loop Action</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>Loop Action</em>'.
	 * @generated
	 */
    LoopAction createLoopAction();

    /**
	 * Returns a new object of class '<em>Branch Action</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>Branch Action</em>'.
	 * @generated
	 */
    BranchAction createBranchAction();

    /**
	 * Returns a new object of class '<em>Action Reference</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>Action Reference</em>'.
	 * @generated
	 */
    ActionReference createActionReference();

    /**
	 * Returns a new object of class '<em>Plan</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>Plan</em>'.
	 * @generated
	 */
    AdaptationPlan createAdaptationPlan();

    /**
	 * Returns a new object of class '<em>Action</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>Action</em>'.
	 * @generated
	 */
    Action createAction();

    /**
	 * Returns a new object of class '<em>Action Operation</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>Action Operation</em>'.
	 * @generated
	 */
    AdaptationActionOperation createAdaptationActionOperation();

    /**
	 * Returns a new object of class '<em>Parameter</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>Parameter</em>'.
	 * @generated
	 */
    Parameter createParameter();

    /**
	 * Returns a new object of class '<em>Import Declaration</em>'.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return a new object of class '<em>Import Declaration</em>'.
	 * @generated
	 */
    ImportDeclaration createImportDeclaration();

    /**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
    AdaptationPackage getAdaptationPackage();

} //AdaptationFactory
