/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.adaptationpoints.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.impl.EFactoryImpl;
import org.eclipse.emf.ecore.plugin.EcorePlugin;

import edu.kit.ipd.descartes.mm.adaptationpoints.AdaptationPointDescriptions;
import edu.kit.ipd.descartes.mm.adaptationpoints.AdaptationpointsFactory;
import edu.kit.ipd.descartes.mm.adaptationpoints.AdaptationpointsPackage;
import edu.kit.ipd.descartes.mm.adaptationpoints.ModelEntityConfigurationRange;
import edu.kit.ipd.descartes.mm.adaptationpoints.ModelVariableConfigurationRange;
import edu.kit.ipd.descartes.mm.adaptationpoints.OclConstraint;
import edu.kit.ipd.descartes.mm.adaptationpoints.PropertyRange;
import edu.kit.ipd.descartes.mm.adaptationpoints.SetOfConfigurations;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class AdaptationpointsFactoryImpl extends EFactoryImpl implements AdaptationpointsFactory {
    /**
     * Creates the default factory implementation.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public static AdaptationpointsFactory init() {
        try {
            AdaptationpointsFactory theAdaptationpointsFactory = (AdaptationpointsFactory)EPackage.Registry.INSTANCE.getEFactory("http://www.descartes-research.net/metamodel/adaptationpoints/0.1"); 
            if (theAdaptationpointsFactory != null) {
                return theAdaptationpointsFactory;
            }
        }
        catch (Exception exception) {
            EcorePlugin.INSTANCE.log(exception);
        }
        return new AdaptationpointsFactoryImpl();
    }

    /**
     * Creates an instance of the factory.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public AdaptationpointsFactoryImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public EObject create(EClass eClass) {
        switch (eClass.getClassifierID()) {
            case AdaptationpointsPackage.ADAPTATION_POINT_DESCRIPTIONS: return createAdaptationPointDescriptions();
            case AdaptationpointsPackage.MODEL_VARIABLE_CONFIGURATION_RANGE: return createModelVariableConfigurationRange();
            case AdaptationpointsPackage.MODEL_ENTITY_CONFIGURATION_RANGE: return createModelEntityConfigurationRange();
            case AdaptationpointsPackage.PROPERTY_RANGE: return createPropertyRange();
            case AdaptationpointsPackage.SET_OF_CONFIGURATIONS: return createSetOfConfigurations();
            case AdaptationpointsPackage.OCL_CONSTRAINT: return createOclConstraint();
            default:
                throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
        }
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public AdaptationPointDescriptions createAdaptationPointDescriptions() {
        AdaptationPointDescriptionsImpl adaptationPointDescriptions = new AdaptationPointDescriptionsImpl();
        return adaptationPointDescriptions;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ModelVariableConfigurationRange createModelVariableConfigurationRange() {
        ModelVariableConfigurationRangeImpl modelVariableConfigurationRange = new ModelVariableConfigurationRangeImpl();
        return modelVariableConfigurationRange;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ModelEntityConfigurationRange createModelEntityConfigurationRange() {
        ModelEntityConfigurationRangeImpl modelEntityConfigurationRange = new ModelEntityConfigurationRangeImpl();
        return modelEntityConfigurationRange;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public PropertyRange createPropertyRange() {
        PropertyRangeImpl propertyRange = new PropertyRangeImpl();
        return propertyRange;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public SetOfConfigurations createSetOfConfigurations() {
        SetOfConfigurationsImpl setOfConfigurations = new SetOfConfigurationsImpl();
        return setOfConfigurations;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public OclConstraint createOclConstraint() {
        OclConstraintImpl oclConstraint = new OclConstraintImpl();
        return oclConstraint;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public AdaptationpointsPackage getAdaptationpointsPackage() {
        return (AdaptationpointsPackage)getEPackage();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @deprecated
     * @generated
     */
    @Deprecated
    public static AdaptationpointsPackage getPackage() {
        return AdaptationpointsPackage.eINSTANCE;
    }

} //AdaptationpointsFactoryImpl
