/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.repository;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Requiring Delegation Connector</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.RequiringDelegationConnector#getParentStructure <em>Parent Structure</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.RequiringDelegationConnector#getInnerInterfaceRequiringRole <em>Inner Interface Requiring Role</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.RequiringDelegationConnector#getOuterInterfaceRequiringRole <em>Outer Interface Requiring Role</em>}</li>
 * </ul>
 * </p>
 *
 * @see edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage#getRequiringDelegationConnector()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='DelegationConnectorAndTheConnectedComponentMustBePartOfTheSameCompositeStructure ComponentOfAssemblyContextAndInnerRoleRequiringComponentNeedToBeTheSame RequiringEntityOfOuterInterfaceRequiringRoleMustBeTheSameAsTheParentOfTheRequiredDelegationConnector'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot DelegationConnectorAndTheConnectedComponentMustBePartOfTheSameCompositeStructure='\n\t\tself.parentStructure = self.assemblyContext.parentStructure' ComponentOfAssemblyContextAndInnerRoleRequiringComponentNeedToBeTheSame='\n\t\tself.assemblyContext.encapsulatedComponent = self.innerInterfaceRequiringRole.interfaceRequiringEntity' RequiringEntityOfOuterInterfaceRequiringRoleMustBeTheSameAsTheParentOfTheRequiredDelegationConnector='\n\t\tself.parentStructure = self.outerInterfaceRequiringRole.interfaceRequiringEntity'"
 * @generated
 */
public interface RequiringDelegationConnector extends DelegationConnector {
	/**
	 * Returns the value of the '<em><b>Parent Structure</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.ComposedStructure#getRequiringDelegationConnectors <em>Requiring Delegation Connectors</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Parent Structure</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Parent Structure</em>' container reference.
	 * @see #setParentStructure(ComposedStructure)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage#getRequiringDelegationConnector_ParentStructure()
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.repository.ComposedStructure#getRequiringDelegationConnectors
	 * @model opposite="requiringDelegationConnectors" required="true" transient="false"
	 * @generated
	 */
	ComposedStructure getParentStructure();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.RequiringDelegationConnector#getParentStructure <em>Parent Structure</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Parent Structure</em>' container reference.
	 * @see #getParentStructure()
	 * @generated
	 */
	void setParentStructure(ComposedStructure value);

	/**
	 * Returns the value of the '<em><b>Inner Interface Requiring Role</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Inner Interface Requiring Role</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Inner Interface Requiring Role</em>' reference.
	 * @see #setInnerInterfaceRequiringRole(InterfaceRequiringRole)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage#getRequiringDelegationConnector_InnerInterfaceRequiringRole()
	 * @model required="true"
	 * @generated
	 */
	InterfaceRequiringRole getInnerInterfaceRequiringRole();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.RequiringDelegationConnector#getInnerInterfaceRequiringRole <em>Inner Interface Requiring Role</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Inner Interface Requiring Role</em>' reference.
	 * @see #getInnerInterfaceRequiringRole()
	 * @generated
	 */
	void setInnerInterfaceRequiringRole(InterfaceRequiringRole value);

	/**
	 * Returns the value of the '<em><b>Outer Interface Requiring Role</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Outer Interface Requiring Role</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Outer Interface Requiring Role</em>' reference.
	 * @see #setOuterInterfaceRequiringRole(InterfaceRequiringRole)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage#getRequiringDelegationConnector_OuterInterfaceRequiringRole()
	 * @model required="true"
	 * @generated
	 */
	InterfaceRequiringRole getOuterInterfaceRequiringRole();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.RequiringDelegationConnector#getOuterInterfaceRequiringRole <em>Outer Interface Requiring Role</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Outer Interface Requiring Role</em>' reference.
	 * @see #getOuterInterfaceRequiringRole()
	 * @generated
	 */
	void setOuterInterfaceRequiringRole(InterfaceRequiringRole value);

} // RequiringDelegationConnector
