/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.repository.impl;

import edu.kit.ipd.descartes.core.impl.EntityImpl;

import edu.kit.ipd.descartes.mm.applicationlevel.repository.AssemblyContext;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.ComposedStructure;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryComponent;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EcoreUtil;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Assembly Context</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.impl.AssemblyContextImpl#getParentStructure <em>Parent Structure</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.impl.AssemblyContextImpl#getEncapsulatedComponent <em>Encapsulated Component</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class AssemblyContextImpl extends EntityImpl implements AssemblyContext {
	/**
	 * The cached value of the '{@link #getEncapsulatedComponent() <em>Encapsulated Component</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEncapsulatedComponent()
	 * @generated
	 * @ordered
	 */
	protected RepositoryComponent encapsulatedComponent;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AssemblyContextImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RepositoryPackage.Literals.ASSEMBLY_CONTEXT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposedStructure getParentStructure() {
		if (eContainerFeatureID() != RepositoryPackage.ASSEMBLY_CONTEXT__PARENT_STRUCTURE) return null;
		return (ComposedStructure)eInternalContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetParentStructure(ComposedStructure newParentStructure, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newParentStructure, RepositoryPackage.ASSEMBLY_CONTEXT__PARENT_STRUCTURE, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentStructure(ComposedStructure newParentStructure) {
		if (newParentStructure != eInternalContainer() || (eContainerFeatureID() != RepositoryPackage.ASSEMBLY_CONTEXT__PARENT_STRUCTURE && newParentStructure != null)) {
			if (EcoreUtil.isAncestor(this, newParentStructure))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newParentStructure != null)
				msgs = ((InternalEObject)newParentStructure).eInverseAdd(this, RepositoryPackage.COMPOSED_STRUCTURE__ASSEMBLY_CONTEXTS, ComposedStructure.class, msgs);
			msgs = basicSetParentStructure(newParentStructure, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.ASSEMBLY_CONTEXT__PARENT_STRUCTURE, newParentStructure, newParentStructure));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RepositoryComponent getEncapsulatedComponent() {
		if (encapsulatedComponent != null && encapsulatedComponent.eIsProxy()) {
			InternalEObject oldEncapsulatedComponent = (InternalEObject)encapsulatedComponent;
			encapsulatedComponent = (RepositoryComponent)eResolveProxy(oldEncapsulatedComponent);
			if (encapsulatedComponent != oldEncapsulatedComponent) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RepositoryPackage.ASSEMBLY_CONTEXT__ENCAPSULATED_COMPONENT, oldEncapsulatedComponent, encapsulatedComponent));
			}
		}
		return encapsulatedComponent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RepositoryComponent basicGetEncapsulatedComponent() {
		return encapsulatedComponent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEncapsulatedComponent(RepositoryComponent newEncapsulatedComponent) {
		RepositoryComponent oldEncapsulatedComponent = encapsulatedComponent;
		encapsulatedComponent = newEncapsulatedComponent;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.ASSEMBLY_CONTEXT__ENCAPSULATED_COMPONENT, oldEncapsulatedComponent, encapsulatedComponent));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case RepositoryPackage.ASSEMBLY_CONTEXT__PARENT_STRUCTURE:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetParentStructure((ComposedStructure)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case RepositoryPackage.ASSEMBLY_CONTEXT__PARENT_STRUCTURE:
				return basicSetParentStructure(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case RepositoryPackage.ASSEMBLY_CONTEXT__PARENT_STRUCTURE:
				return eInternalContainer().eInverseRemove(this, RepositoryPackage.COMPOSED_STRUCTURE__ASSEMBLY_CONTEXTS, ComposedStructure.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RepositoryPackage.ASSEMBLY_CONTEXT__PARENT_STRUCTURE:
				return getParentStructure();
			case RepositoryPackage.ASSEMBLY_CONTEXT__ENCAPSULATED_COMPONENT:
				if (resolve) return getEncapsulatedComponent();
				return basicGetEncapsulatedComponent();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RepositoryPackage.ASSEMBLY_CONTEXT__PARENT_STRUCTURE:
				setParentStructure((ComposedStructure)newValue);
				return;
			case RepositoryPackage.ASSEMBLY_CONTEXT__ENCAPSULATED_COMPONENT:
				setEncapsulatedComponent((RepositoryComponent)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case RepositoryPackage.ASSEMBLY_CONTEXT__PARENT_STRUCTURE:
				setParentStructure((ComposedStructure)null);
				return;
			case RepositoryPackage.ASSEMBLY_CONTEXT__ENCAPSULATED_COMPONENT:
				setEncapsulatedComponent((RepositoryComponent)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RepositoryPackage.ASSEMBLY_CONTEXT__PARENT_STRUCTURE:
				return getParentStructure() != null;
			case RepositoryPackage.ASSEMBLY_CONTEXT__ENCAPSULATED_COMPONENT:
				return encapsulatedComponent != null;
		}
		return super.eIsSet(featureID);
	}

} //AssemblyContextImpl
