/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl;

import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.BranchAction;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.BranchProbabilities;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ComponentInternalBehavior;
import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Branch Action</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl.BranchActionImpl#getBranches <em>Branches</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.impl.BranchActionImpl#getBranchProbabilities <em>Branch Probabilities</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class BranchActionImpl extends AbstractActionImpl implements BranchAction {
	/**
	 * The cached value of the '{@link #getBranches() <em>Branches</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBranches()
	 * @generated
	 * @ordered
	 */
	protected EList<ComponentInternalBehavior> branches;

	/**
	 * The cached value of the '{@link #getBranchProbabilities() <em>Branch Probabilities</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBranchProbabilities()
	 * @generated
	 * @ordered
	 */
	protected BranchProbabilities branchProbabilities;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BranchActionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ServicebehaviorPackage.Literals.BRANCH_ACTION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ComponentInternalBehavior> getBranches() {
		if (branches == null) {
			branches = new EObjectContainmentEList<ComponentInternalBehavior>(ComponentInternalBehavior.class, this, ServicebehaviorPackage.BRANCH_ACTION__BRANCHES);
		}
		return branches;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BranchProbabilities getBranchProbabilities() {
		return branchProbabilities;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetBranchProbabilities(BranchProbabilities newBranchProbabilities, NotificationChain msgs) {
		BranchProbabilities oldBranchProbabilities = branchProbabilities;
		branchProbabilities = newBranchProbabilities;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ServicebehaviorPackage.BRANCH_ACTION__BRANCH_PROBABILITIES, oldBranchProbabilities, newBranchProbabilities);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setBranchProbabilities(BranchProbabilities newBranchProbabilities) {
		if (newBranchProbabilities != branchProbabilities) {
			NotificationChain msgs = null;
			if (branchProbabilities != null)
				msgs = ((InternalEObject)branchProbabilities).eInverseRemove(this, ServicebehaviorPackage.BRANCH_PROBABILITIES__BRANCH_ACTION, BranchProbabilities.class, msgs);
			if (newBranchProbabilities != null)
				msgs = ((InternalEObject)newBranchProbabilities).eInverseAdd(this, ServicebehaviorPackage.BRANCH_PROBABILITIES__BRANCH_ACTION, BranchProbabilities.class, msgs);
			msgs = basicSetBranchProbabilities(newBranchProbabilities, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ServicebehaviorPackage.BRANCH_ACTION__BRANCH_PROBABILITIES, newBranchProbabilities, newBranchProbabilities));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ServicebehaviorPackage.BRANCH_ACTION__BRANCH_PROBABILITIES:
				if (branchProbabilities != null)
					msgs = ((InternalEObject)branchProbabilities).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ServicebehaviorPackage.BRANCH_ACTION__BRANCH_PROBABILITIES, null, msgs);
				return basicSetBranchProbabilities((BranchProbabilities)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ServicebehaviorPackage.BRANCH_ACTION__BRANCHES:
				return ((InternalEList<?>)getBranches()).basicRemove(otherEnd, msgs);
			case ServicebehaviorPackage.BRANCH_ACTION__BRANCH_PROBABILITIES:
				return basicSetBranchProbabilities(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ServicebehaviorPackage.BRANCH_ACTION__BRANCHES:
				return getBranches();
			case ServicebehaviorPackage.BRANCH_ACTION__BRANCH_PROBABILITIES:
				return getBranchProbabilities();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ServicebehaviorPackage.BRANCH_ACTION__BRANCHES:
				getBranches().clear();
				getBranches().addAll((Collection<? extends ComponentInternalBehavior>)newValue);
				return;
			case ServicebehaviorPackage.BRANCH_ACTION__BRANCH_PROBABILITIES:
				setBranchProbabilities((BranchProbabilities)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ServicebehaviorPackage.BRANCH_ACTION__BRANCHES:
				getBranches().clear();
				return;
			case ServicebehaviorPackage.BRANCH_ACTION__BRANCH_PROBABILITIES:
				setBranchProbabilities((BranchProbabilities)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ServicebehaviorPackage.BRANCH_ACTION__BRANCHES:
				return branches != null && !branches.isEmpty();
			case ServicebehaviorPackage.BRANCH_ACTION__BRANCH_PROBABILITIES:
				return branchProbabilities != null;
		}
		return super.eIsSet(featureID);
	}

} //BranchActionImpl
