/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.resourceconfiguration.util;

import edu.kit.ipd.descartes.core.AdaptableEntity;
import edu.kit.ipd.descartes.core.Entity;
import edu.kit.ipd.descartes.core.NamedElement;

import edu.kit.ipd.descartes.identifier.Identifier;

import edu.kit.ipd.descartes.mm.resourceconfiguration.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see edu.kit.ipd.descartes.mm.resourceconfiguration.ResourceconfigurationPackage
 * @generated
 */
public class ResourceconfigurationAdapterFactory extends AdapterFactoryImpl {
	/**
     * The cached model package.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	protected static ResourceconfigurationPackage modelPackage;

	/**
     * Creates an instance of the adapter factory.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public ResourceconfigurationAdapterFactory() {
        if (modelPackage == null) {
            modelPackage = ResourceconfigurationPackage.eINSTANCE;
        }
    }

	/**
     * Returns whether this factory is applicable for the type of the object.
     * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
     * @return whether this factory is applicable for the type of the object.
     * @generated
     */
	@Override
	public boolean isFactoryForType(Object object) {
        if (object == modelPackage) {
            return true;
        }
        if (object instanceof EObject) {
            return ((EObject)object).eClass().getEPackage() == modelPackage;
        }
        return false;
    }

	/**
     * The switch that delegates to the <code>createXXX</code> methods.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	protected ResourceconfigurationSwitch<Adapter> modelSwitch =
		new ResourceconfigurationSwitch<Adapter>() {
            @Override
            public Adapter caseConfigurationSpecification(ConfigurationSpecification object) {
                return createConfigurationSpecificationAdapter();
            }
            @Override
            public Adapter caseProcessingResourceSpecification(ProcessingResourceSpecification object) {
                return createProcessingResourceSpecificationAdapter();
            }
            @Override
            public Adapter caseNumberOfParallelProcessingUnits(NumberOfParallelProcessingUnits object) {
                return createNumberOfParallelProcessingUnitsAdapter();
            }
            @Override
            public Adapter caseLinkingResourceSpecification(LinkingResourceSpecification object) {
                return createLinkingResourceSpecificationAdapter();
            }
            @Override
            public Adapter caseActiveResourceSpecification(ActiveResourceSpecification object) {
                return createActiveResourceSpecificationAdapter();
            }
            @Override
            public Adapter caseCustomConfigurationSpecification(CustomConfigurationSpecification object) {
                return createCustomConfigurationSpecificationAdapter();
            }
            @Override
            public Adapter casePassiveResourceSpecification(PassiveResourceSpecification object) {
                return createPassiveResourceSpecificationAdapter();
            }
            @Override
            public Adapter casePassiveResourceCapacity(PassiveResourceCapacity object) {
                return createPassiveResourceCapacityAdapter();
            }
            @Override
            public Adapter caseCustomResourceConfigurationModel(CustomResourceConfigurationModel object) {
                return createCustomResourceConfigurationModelAdapter();
            }
            @Override
            public Adapter caseIdentifier(Identifier object) {
                return createIdentifierAdapter();
            }
            @Override
            public Adapter caseNamedElement(NamedElement object) {
                return createNamedElementAdapter();
            }
            @Override
            public Adapter caseEntity(Entity object) {
                return createEntityAdapter();
            }
            @Override
            public Adapter caseAdaptableEntity(AdaptableEntity object) {
                return createAdaptableEntityAdapter();
            }
            @Override
            public Adapter defaultCase(EObject object) {
                return createEObjectAdapter();
            }
        };

	/**
     * Creates an adapter for the <code>target</code>.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @param target the object to adapt.
     * @return the adapter for the <code>target</code>.
     * @generated
     */
	@Override
	public Adapter createAdapter(Notifier target) {
        return modelSwitch.doSwitch((EObject)target);
    }


	/**
     * Creates a new adapter for an object of class '{@link edu.kit.ipd.descartes.mm.resourceconfiguration.ConfigurationSpecification <em>Configuration Specification</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see edu.kit.ipd.descartes.mm.resourceconfiguration.ConfigurationSpecification
     * @generated
     */
	public Adapter createConfigurationSpecificationAdapter() {
        return null;
    }

	/**
     * Creates a new adapter for an object of class '{@link edu.kit.ipd.descartes.mm.resourceconfiguration.ProcessingResourceSpecification <em>Processing Resource Specification</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see edu.kit.ipd.descartes.mm.resourceconfiguration.ProcessingResourceSpecification
     * @generated
     */
	public Adapter createProcessingResourceSpecificationAdapter() {
        return null;
    }

	/**
     * Creates a new adapter for an object of class '{@link edu.kit.ipd.descartes.mm.resourceconfiguration.NumberOfParallelProcessingUnits <em>Number Of Parallel Processing Units</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see edu.kit.ipd.descartes.mm.resourceconfiguration.NumberOfParallelProcessingUnits
     * @generated
     */
	public Adapter createNumberOfParallelProcessingUnitsAdapter() {
        return null;
    }

	/**
     * Creates a new adapter for an object of class '{@link edu.kit.ipd.descartes.mm.resourceconfiguration.LinkingResourceSpecification <em>Linking Resource Specification</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see edu.kit.ipd.descartes.mm.resourceconfiguration.LinkingResourceSpecification
     * @generated
     */
	public Adapter createLinkingResourceSpecificationAdapter() {
        return null;
    }

	/**
     * Creates a new adapter for an object of class '{@link edu.kit.ipd.descartes.mm.resourceconfiguration.ActiveResourceSpecification <em>Active Resource Specification</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see edu.kit.ipd.descartes.mm.resourceconfiguration.ActiveResourceSpecification
     * @generated
     */
	public Adapter createActiveResourceSpecificationAdapter() {
        return null;
    }

	/**
     * Creates a new adapter for an object of class '{@link edu.kit.ipd.descartes.mm.resourceconfiguration.CustomConfigurationSpecification <em>Custom Configuration Specification</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see edu.kit.ipd.descartes.mm.resourceconfiguration.CustomConfigurationSpecification
     * @generated
     */
	public Adapter createCustomConfigurationSpecificationAdapter() {
        return null;
    }

	/**
     * Creates a new adapter for an object of class '{@link edu.kit.ipd.descartes.mm.resourceconfiguration.PassiveResourceSpecification <em>Passive Resource Specification</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see edu.kit.ipd.descartes.mm.resourceconfiguration.PassiveResourceSpecification
     * @generated
     */
	public Adapter createPassiveResourceSpecificationAdapter() {
        return null;
    }

	/**
     * Creates a new adapter for an object of class '{@link edu.kit.ipd.descartes.mm.resourceconfiguration.PassiveResourceCapacity <em>Passive Resource Capacity</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see edu.kit.ipd.descartes.mm.resourceconfiguration.PassiveResourceCapacity
     * @generated
     */
	public Adapter createPassiveResourceCapacityAdapter() {
        return null;
    }

	/**
     * Creates a new adapter for an object of class '{@link edu.kit.ipd.descartes.mm.resourceconfiguration.CustomResourceConfigurationModel <em>Custom Resource Configuration Model</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see edu.kit.ipd.descartes.mm.resourceconfiguration.CustomResourceConfigurationModel
     * @generated
     */
    public Adapter createCustomResourceConfigurationModelAdapter() {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link edu.kit.ipd.descartes.identifier.Identifier <em>Identifier</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see edu.kit.ipd.descartes.identifier.Identifier
     * @generated
     */
	public Adapter createIdentifierAdapter() {
        return null;
    }

	/**
     * Creates a new adapter for an object of class '{@link edu.kit.ipd.descartes.core.NamedElement <em>Named Element</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see edu.kit.ipd.descartes.core.NamedElement
     * @generated
     */
	public Adapter createNamedElementAdapter() {
        return null;
    }

	/**
     * Creates a new adapter for an object of class '{@link edu.kit.ipd.descartes.core.Entity <em>Entity</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see edu.kit.ipd.descartes.core.Entity
     * @generated
     */
	public Adapter createEntityAdapter() {
        return null;
    }

	/**
     * Creates a new adapter for an object of class '{@link edu.kit.ipd.descartes.core.AdaptableEntity <em>Adaptable Entity</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see edu.kit.ipd.descartes.core.AdaptableEntity
     * @generated
     */
	public Adapter createAdaptableEntityAdapter() {
        return null;
    }

	/**
     * Creates a new adapter for the default case.
     * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @generated
     */
	public Adapter createEObjectAdapter() {
        return null;
    }

} //ResourceconfigurationAdapterFactory
